<?php if (!defined('ITPK')) exit('You can not directly access the file.');

/**
 * 茉莉机器人API插件
 * @author 冬天的秘密
 * @link http://bbs.itpk.cn
 * @version 1.0
 */

class WebapiHandler extends AbstractpluginHandler {

	/**
	 * 插件入口方法，所有插件都必须有main方法和继承AbstractpluginHandler类
	 */
	public function main() {
		$msg = (DataUtil::is_empty($this->msg) || DataUtil::is_contain("[faceArrayend]", $this->msg)) ? "[img:no]" : $this->msg;
		$api = $this->getMe();
		if ($api) {
			$api_key = $api['api_key'];
			$api_secret = $api['api_secret'];
			$status = $api['status'];
			$prefix = $api['prefix'];
			if ($this->is_permissions() || $this->is_manager()) {
				if ($status == "setapi") {
					list($api_key, $api_secret) = explode(",", $msg);
					if (DataUtil::is_empty($api_key) || DataUtil::is_empty($api_secret)) {
						$result = false;
					} else {
						$result = $this->updateApiKeyAndSecret($api_key, $api_secret);
					}
				} elseif ($status == "setprefix") {
					if (mb_strlen($msg, "utf8") == 1) {
						$msg = ($msg == "空") ? "" : $msg;
						$result = $this->updatePrefix($msg);
					} else {
						$result = false;
					}
				} elseif ($status == "truncate") {
					if ($msg == "是" || $msg == "y") {
						$result = $this->runlogPer->deleteMeByRobotId($this->robot['id']);
					} else {
						$result = false;
					}
				}
				if (isset($result)) {
					//退出当前设置并回复设置结果
					$this->updatePluginId();
					$this->updateStatus("");
					return ReplyUtil::getReply($result ? "执行成功" : "执行失败");
				}
				if ($msg == "设置机器人API") {
					$this->updateStatus("setapi");
					return ReplyUtil::getReply("请输入您的api_key和api_secret（中间用“,”隔开）：");
				} elseif ($msg == "设置聊天前缀") {
					$this->updateStatus("setprefix");
					return ReplyUtil::getReply("请输入要设置的聊天前缀（必须是一个字符，字母、数字、符号或中文等）：");
				} elseif ($msg == "取消聊天前缀") {
					$this->updatePluginId();
					$result = $this->updatePrefix();
					return ReplyUtil::getReply($result ? "执行成功" : "执行失败");
				} elseif ($msg == "清空运行记录") {
					$this->updateStatus("truncate");
					return ReplyUtil::getReply("确定清空所有运行记录（该记录包括聊天记录和系统执行记录）吗？（是/否）");
				} 
				if ($this->msg_type == MsgUtil::GROUP_MSG) {
					$this->updatePluginId();
					if (DataUtil::start_contain("禁言", $msg)) {
						$profile = explode("禁言", $msg);
						$profile = explode("|", $profile[1]);
						$member_uin = trim($profile[0]);
						$time_memo = trim($profile[1]);
						$result = $this->setMemberSpeech($this->object['group_uin'], $member_uin, $time_memo);
						return ReplyUtil::getReply($result ? "禁言{$member_uin}执行成功" : "禁言{$member_uin}执行失败");
					} elseif (DataUtil::start_contain("改名片", $msg)) {
						$profile = explode("改名片", $msg);
						$profile = explode("|", $profile[1]);
						if (count($profile) > 1) {
							$member_uin = trim($profile[0]);
							$card_name = trim($profile[1]);
							$result = $this->updateMemberCard($this->object['group_uin'], $member_uin, $card_name);
							return ReplyUtil::getReply($result ? "名片修改成功" : "名片修改失败");
						}
					} elseif (DataUtil::start_contain("踢人", $msg)) {
						$profile = explode("踢人", $msg);
						$member_uin = trim($profile[1]);
						$result = $this->removeMember($this->object['group_uin'], $member_uin);
						return ReplyUtil::getReply($result ? "{$member_uin}已被移出此群" : "{$member_uin}移出失败");
					} elseif (DataUtil::start_contain("加金币", $msg)) {
						$profile = explode("加金币", $msg);
						$profile = explode("|", $profile[1]);
						if (count($profile) > 1) {
							$member_uin = trim($profile[0]);
							$gold = trim($profile[1]);
							if (is_numeric($gold)) {
								$result = $this->groupmemberPer->updateGoldByManager($this->robot['id'], $this->object['group_uin'], $member_uin, $gold, true);
								return ReplyUtil::getReply($result ? "金币充值成功，请注意查收" : "金币充值失败");
							}
						}
					} elseif (DataUtil::start_contain("减金币", $msg)) {
						$profile = explode("减金币", $msg);
						$profile = explode("|", $profile[1]);
						if (count($profile) > 1) {
							$member_uin = trim($profile[0]);
							$gold = trim($profile[1]);
							if (is_numeric($gold)) {
								$result = $this->groupmemberPer->updateGoldByManager($this->robot['id'], $this->object['group_uin'], $member_uin, $gold, false);
								return ReplyUtil::getReply($result ? "金币没收成功" : "金币没收失败");
							}
						}
					}
				}
			}
			$this->updatePluginId();
			if ($this->msg_type == MsgUtil::GROUP_MSG) {
				if (DataUtil::is_contain(array("我", "老子", "劳资", "帅逼", "帅比", "me", "wo", "哥"), $msg, true, true) && DataUtil::is_contain("禁言", $msg)) {
					$time = preg_replace('/^(.*?)(\d{1,5})(.*?)$/i', '\\2', $msg);
					if (is_numeric($time) && $time > 0) {
						if (DataUtil::is_contain("天", $msg)) {
							$time .= "天";
						} elseif (DataUtil::is_contain("小时", $msg)) {
							$time .= "小时";
						} elseif (DataUtil::is_contain("分钟", $msg)) {
							$time .= "分钟";
						}
						if (!is_numeric($time)) {
							if ($this->setMemberSpeechBySelf($time)) {
								return ReplyUtil::getReply("你想禁言自己啊,那成全你喽.");
							}
						}
					}
				} elseif (DataUtil::start_contain("改名片", $msg)) {
					$profile = explode("改名片", $msg);
					$card_name = trim($profile[1]);
					if (!DataUtil::is_empty($card_name)) {
						if ($this->updateMemberCardSelf($card_name)) {
							return ReplyUtil::getReply("名片[$card_name]修改成功");
						}
					}
				} elseif (DataUtil::is_equal("个人中心", $msg)) {
					$gold = $this->object['gold'];
					$experience = $this->object['experience'];
					$nick_name = $this->object['nick_name'];
					$nick_name = preg_replace("/\s/", "", $nick_name);
					$nick_name = preg_replace("/<br>/", "", $nick_name);
					$reply = "@" . $nick_name . "的个人中心" . CR;
					$reply .= "我的金币：" . $gold . CR;
					$reply .= "我的经验：" . $experience;
					return ReplyUtil::getReply($reply);
				}
			}
			$msg_prefix = mb_substr($msg, 0, 1, "utf8");
			if ($prefix != "" && $prefix != $msg_prefix) {
				return ReplyUtil::noReply();
			}
			$msg = !DataUtil::is_empty($prefix) ? mb_substr($msg, 1, mb_strlen($msg, "utf8") - 1, "utf8") : $msg;
			return $this->reply($api_key, $api_secret, $msg);
		} else {
			$this->updatePluginId();
			$this->insertMe();
			return ReplyUtil::getReply("茉莉机器人API初始化完毕，请机器人创建者进行相关设置");
		}
	}

	/**
	 * 从茉莉机器人API获取回复
	 * @param string $api_key
	 * @param string $api_secret
	 * @param string $msg
	 * @return string
	 */
	public function reply($api_key, $api_secret, $msg) {
		if (DataUtil::is_contain(array("+","-","*","/","%","加","减","乘","除","除以"), $msg, true)) {
			$reply = $this->beta_reply($msg);
			if ($reply != "") {
				return ReplyUtil::getReply($reply);
			}
		}
		if (DataUtil::start_contain("sjh", $msg) || DataUtil::start_contain("qq", $msg) || DataUtil::start_contain("lol", $msg) || DataUtil::start_contain("cy", $msg) || DataUtil::start_contain("sfz", $msg) || DataUtil::start_contain("tq", $msg) || DataUtil::start_contain("ip", $msg)) {
			$msg = "@" . $msg;
		}
		$apiurl = "http://i.itpk.cn/api.php?question=" . urlencode($msg) . "&api_key={$api_key}&api_secret={$api_secret}";
		$curl_obj = curl_init();
		curl_setopt($curl_obj, CURLOPT_URL, $apiurl);
		curl_setopt($curl_obj, CURLOPT_HEADER, 0);
		curl_setopt($curl_obj, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($curl_obj, CURLOPT_CONNECTTIMEOUT, 6);
		$result = curl_exec($curl_obj);
		curl_close($curl_obj);
		if (DataUtil::is_contain("笑话", $msg)) {
			$joke = json_decode($result, true);
			$title = $joke['title'];
			$content = $joke['content'];
			$result = "[face95end]" . $title . "[face95end]%5C%5Cn" . $content;
		} elseif (DataUtil::is_empty($api_key) || DataUtil::is_empty($api_secret)) {
			$iqname = $this->robotPer->getProfile($this->robot);
			$result = preg_replace('/\[cqname\]/Uis', $iqname, $result);
			$result = preg_replace('/\[name\]/Uis', "你", $result);
		}
		return ReplyUtil::getReply($result);
	}

	public function beta_reply($msg) {
		$apiurl = "http://api.itpk.cn/api.php?q=" . urlencode($msg) . "&key=abc&secret=123&type=json";
		$curl_obj = curl_init();
		curl_setopt($curl_obj, CURLOPT_URL, $apiurl);
		curl_setopt($curl_obj, CURLOPT_HEADER, 0);
		curl_setopt($curl_obj, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($curl_obj, CURLOPT_CONNECTTIMEOUT, 6);
		$result = curl_exec($curl_obj);
		curl_close($curl_obj);
		$json = json_decode($result);
		$reply = "";
		if ($json->code == "20002" && $json->status == "success") {
			$json_result = $json->result;
			for ($i = 0; $i < count($json_result); $i++) {
				if ($reply != "") {
					$reply .= CR;
				}
				$reply .= $json_result[$i];
			}
			$reply = urlencode($reply);
		} elseif ($json->code == "20001" && $json->status == "success") {
			$json_result = $json->result;
			if (!DataUtil::is_empty($json_result)) {
				$match_mode = $json_result->match_mode;
				$rank_mode = $json_result->rank_mode;
				$reply .= ($json_result->server_name . "（" . $json_result->server_number . "）：" . $json_result->role_name . CR);
				$reply .= ("等级：" . $json_result->level . CR);
				$reply .= ("战斗力：" . $json_result->fight_capacity . CR);
				$reply .= ("段位：" . $json_result->tier . $json_result->rank . CR);
				$reply .= ("胜点：" . $json_result->win_point . CR);
				$reply .= ("隐藏分：" . $json_result->rank_point . CR);
				$reply .= ("赞：" . $json_result->praise . CR);
				$reply .= ("拉黑：" . $json_result->black . CR);
				$reply .= ("小学生概率：此人有" . $json_result->pupil . "的可能性是小学生" . CR);
				$reply .= ("最近使用英雄：" . $this->arrayToString($json_result->hero, "、") . CR);
				$reply .= ("关键字：" . $this->arrayToString($json_result->words, "、") . CR);
				$reply .= ("经典匹配：总场次" . $match_mode->trad->total . "，胜率" . $match_mode->trad->odds . "，胜场" . $match_mode->trad->wins . "，负场" . $match_mode->trad->lose . CR);
				$reply .= ("人机模式：总场次" . $match_mode->ai->total . "，胜率" . $match_mode->ai->odds . "，胜场" . $match_mode->ai->wins . "，负场" . $match_mode->ai->lose . CR);
				$reply .= ("大乱斗：总场次" . $match_mode->leisure->total . "，胜率" . $match_mode->leisure->odds . "，胜场" . $match_mode->leisure->wins . "，负场" . $match_mode->leisure->lose . CR);
				$reply .= ("5V5单双排：总场次" . $rank_mode->five_vs->total . "，胜率" . $rank_mode->five_vs->odds . "，胜场" . $rank_mode->five_vs->wins . "，负场" . $rank_mode->five_vs->lose . CR);
				$reply .= ("历史单双排：总场次" . $rank_mode->history->total . "，胜率" . $rank_mode->history->odds . "，胜场" . $rank_mode->history->wins . "，负场" . $rank_mode->history->lose);
			}
		}
		return $reply;
	}

	/**
	 * 获取机器人API
	 * @return array | boolean
	 */
	public function getMe() {
		return $this->db->executeQuery("SELECT * FROM web_api WHERE uin = '{$this->robot['uin']}' ORDER BY id ASC LIMIT 1", true);
	}

	/**
	 * 更新插件的运行状态
	 * @param string $status
	 * @return boolean
	 */
	public function updateStatus($status = "") {
		return $this->db->executeQuery("UPDATE web_api SET status = '{$status}' WHERE uin = '{$this->robot['uin']}'") > 0 ? true : false;
	}

	/**
	 * 设置聊天前缀
	 * @param string $status
	 * @return boolean
	 */
	public function updatePrefix($prefix = "") {
		return $this->db->executeQuery("UPDATE web_api SET prefix = '{$prefix}' WHERE uin = '{$this->robot['uin']}'") > 0 ? true : false;
	}

	/**
	 * 设置机器人api_key和api_secret
	 * @param string $api_key
	 * @param string $api_secret
	 * @return boolean
	 */
	public function updateApiKeyAndSecret($api_key, $api_secret) {
		return $this->db->executeQuery("UPDATE web_api SET api_key = '{$api_key}', api_secret = '{$api_secret}' WHERE uin = '{$this->robot['uin']}'") > 0 ? true : false;
	}

	/**
	 * 更新或添加机器人API
	 * @param string $api_key
	 * @param string $api_secret
	 */
	public function insertMe($api_key = "", $api_secret = "", $status = "") {
		$count = $this->db->executeQuery("INSERT INTO web_api(uin, api_key, api_secret, status) VALUES('{$this->robot['uin']}', '{$api_key}', '{$api_secret}', '')");
		return $count > 0 ? true : false;
	}

	/**
	 * 把数组的VALUE拼成字符串，用port隔开
	 * @param array $array
	 * @param string $port
	 * @return string
	 */
	public function arrayToString($array, $port) {
		$str = "";
		foreach ($array as $key=>$value) {
			$str .= ($value . $port);
		}
		return rtrim($str, $port);
	}
} 
?>